// testDlg.cpp : implementation file
//

#include "stdafx.h"
#include "test.h"
#include "testDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTestDlg dialog

CTestDlg::CTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	init = FALSE;
	droll = 2.0f;
	dpitch = 1.0f;
	swtimer = FALSE;
	
	srand( (unsigned)time( NULL ) );
}

void CTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestDlg)
	DDX_Control(pDX, IDC_AGAUGE1, AGAUGE1);
	DDX_Control(pDX, IDC_AGAUGE2, AGAUGE2);
	DDX_Control(pDX, IDC_AGAUGE3, AGAUGE3);
	DDX_Control(pDX, IDC_AGAUGE4, AGAUGE4);
	DDX_Control(pDX, IDC_AGAUGE5, AGAUGE5);
	DDX_Control(pDX, IDC_AGAUGE6, AGAUGE6);
	DDX_Control(pDX, IDC_AGAUGE7, AGAUGE7);
	DDX_Control(pDX, IDC_AGAUGE8, AGAUGE8);
	DDX_Control(pDX, IDC_AGAUGE9, AGAUGE9);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestDlg, CDialog)
	//{{AFX_MSG_MAP(CTestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestDlg message handlers

BOOL CTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}

	if (!init) {
		init = TRUE;
		
		SetTimer(1000,50,NULL);
		SetTimer(1001,100,NULL);
		SetTimer(1002,1000,NULL);
		
		swtimer = TRUE;
		}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BEGIN_EVENTSINK_MAP(CTestDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CTestDlg)
	ON_EVENT(CTestDlg, IDC_AGAUGE1, -601 /* DblClick */, OnDblClickAgauge1, VTS_NONE)
	ON_EVENT(CTestDlg, IDC_AGAUGE2, -601 /* DblClick */, OnDblClickAgauge2, VTS_NONE)
	ON_EVENT(CTestDlg, IDC_AGAUGE3, -601 /* DblClick */, OnDblClickAgauge3, VTS_NONE)
	ON_EVENT(CTestDlg, IDC_AGAUGE4, -601 /* DblClick */, OnDblClickAgauge4, VTS_NONE)
	ON_EVENT(CTestDlg, IDC_AGAUGE5, -601 /* DblClick */, OnDblClickAgauge5, VTS_NONE)
	ON_EVENT(CTestDlg, IDC_AGAUGE6, -601 /* DblClick */, OnDblClickAgauge6, VTS_NONE)
	ON_EVENT(CTestDlg, IDC_AGAUGE7, -601 /* DblClick */, OnDblClickAgauge7, VTS_NONE)
	ON_EVENT(CTestDlg, IDC_AGAUGE8, -601 /* DblClick */, OnDblClickAgauge8, VTS_NONE)
	ON_EVENT(CTestDlg, IDC_AGAUGE9, -601 /* DblClick */, OnDblClickAgauge9, VTS_NONE)
	ON_EVENT(CTestDlg, IDC_AGAUGE9, 2 /* Turn */, OnTurnAgauge9, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CTestDlg::OnDblClickAgauge1() 
{
	AGAUGE1.ShowPropertyPage();
}

void CTestDlg::OnDblClickAgauge2() 
{
	AGAUGE2.ShowPropertyPage();
}

void CTestDlg::OnDblClickAgauge3() 
{
	AGAUGE3.ShowPropertyPage();
}

void CTestDlg::OnDblClickAgauge4() 
{
	AGAUGE4.ShowPropertyPage();
}

void CTestDlg::OnDblClickAgauge5() 
{
	AGAUGE5.ShowPropertyPage();
}

void CTestDlg::OnDblClickAgauge6() 
{
	AGAUGE6.ShowPropertyPage();
}

void CTestDlg::OnDblClickAgauge7() 
{
	AGAUGE7.ShowPropertyPage();
}

void CTestDlg::OnDblClickAgauge8() 
{
	AGAUGE8.ShowPropertyPage();
}

void CTestDlg::OnDblClickAgauge9() 
{
	AGAUGE9.ShowPropertyPage();
}

void CTestDlg::OnButton1() 
{
	//stop watch start button
	if (!swtimer) {
		SetTimer(1000,50,NULL);
		swtimer = TRUE;
		}
}

void CTestDlg::OnButton2() 
{
	//stop watch stop button
	if (swtimer) {
		KillTimer(1000);
		swtimer = FALSE;
		}
}

void CTestDlg::OnButton3() 
{
	//stop watch reset button
	AGAUGE6.SetNeedleID(0);
	AGAUGE6.SetNeedleValue(0.0f);
	AGAUGE6.SetNeedleID(1);
	AGAUGE6.SetNeedleValue(0.0f);
	AGAUGE6.SetNeedleID(2);
	AGAUGE6.SetNeedleValue(0.0f);
}

BOOL CTestDlg::DestroyWindow() 
{
	KillTimer(1000);
	KillTimer(1001);
	KillTimer(1002);
	
	swtimer = FALSE;
	
	return CDialog::DestroyWindow();
}

void CTestDlg::OnTimer(UINT nIDEvent) 
{
int i,j,k;
float value;
SYSTEMTIME st;

	switch (nIDEvent) {
		case 1000: // fast timer
			//stop watch
			AGAUGE6.SetNeedleID(1);
			i = (int) AGAUGE6.GetNeedleValue()+1;
			
			if (i > 15) {
				i = 0;
				AGAUGE6.SetNeedleID(0);
				j = (int) AGAUGE6.GetNeedleValue()+1;
				
				if (j > 60) {
					j = 0;
					k = 0;
					AGAUGE6.SetNeedleID(2);
					k = (int) AGAUGE6.GetNeedleValue()+1;
					if (k > 5) k=0;
					AGAUGE6.SetNeedleValue((float) k);
					}
				
				AGAUGE6.SetNeedleID(0);
				AGAUGE6.SetNeedleValue((float) j);
				}
			
			AGAUGE6.SetNeedleID(1);
			AGAUGE6.SetNeedleValue((float) i);
			
			break;
		case 1001: // 1/10 second timer
			value = AGAUGE1.GetNeedleValue() + 2.0f * (float) rand()/(float) RAND_MAX - 1.0f;
			AGAUGE1.SetNeedleValue(value);
			
			AGAUGE3.SetNeedleValue(AGAUGE3.GetNeedleValue() + droll);
			if (AGAUGE3.GetNeedleValue() >= 30.0f) droll = -2.0f;
			if (AGAUGE3.GetNeedleValue() <= -30.0f) droll = 2.0f;
			
		    AGAUGE4.SetNeedleValue(AGAUGE4.GetNeedleValue() + dpitch);
			if (AGAUGE4.GetNeedleValue() >= 30.0f) dpitch = -1.0f;
			if (AGAUGE4.GetNeedleValue() <= -30.0f) dpitch = 1.0f;
			
			value = AGAUGE7.GetNeedleValue() + 1.0f;
			if (value >= 360.0f) value = 0.0f;
			
			AGAUGE7.SetNeedleValue(value);
			
		    AGAUGE7.SetTicID(0);
			AGAUGE7.SetTicFloatOffset(value);
			AGAUGE7.SetTicID(1);
			AGAUGE7.SetTicFloatOffset(value);
			AGAUGE7.SetAnnularID(2);
			AGAUGE7.SetAnnularFloatOffset(value);
			AGAUGE7.SetAnnularID(3);
			AGAUGE7.SetAnnularFloatOffset(value);
			AGAUGE7.SetAnnularID(4);
			AGAUGE7.SetAnnularFloatOffset(value);
			
			break;
		case 1002: // one second timer
			GetLocalTime(&st);
			
			//clock example
			value = (float) st.wHour;
			if (value>=12) value -=12;
			AGAUGE5.SetNeedleID(0);
			AGAUGE5.SetNeedleValue(value + (float) st.wMinute/60.0f);
			AGAUGE5.SetNeedleID(1);
			AGAUGE5.SetNeedleValue((float) st.wMinute);
			AGAUGE5.SetNeedleID(2);
			AGAUGE5.SetNeedleValue((float) st.wSecond);
			break;
		}
	
	CDialog::OnTimer(nIDEvent);
}

void CTestDlg::OnTurnAgauge9() 
{
float Value = AGAUGE9.GetNeedleValue();

    switch (AGAUGE9.GetNeedleID()) {
        case 0: //'Min Needle
            AGAUGE9.SetNeedleID(1);
            if (AGAUGE9.GetNeedleValue() < Value) 
                AGAUGE9.SetNeedleValue(Value);
            
            AGAUGE9.SetNeedleID(2);
            if (AGAUGE9.GetNeedleValue() < Value) 
                AGAUGE9.SetNeedleValue(Value);
            
            AGAUGE9.SetNeedleID(0);
			break;
        case 2: //'Max Needle
            AGAUGE9.SetNeedleID(0);
            if (AGAUGE9.GetNeedleValue() > Value) 
                AGAUGE9.SetNeedleValue(Value);
            
            AGAUGE9.SetNeedleID(1);
            if (AGAUGE9.GetNeedleValue() > Value) 
                AGAUGE9.SetNeedleValue(Value);
            
            AGAUGE9.SetNeedleID(2);
			break;
        case 1: // 'Value Needle
            AGAUGE9.SetNeedleID(0);
            if (AGAUGE9.GetNeedleValue() > Value) 
                AGAUGE9.SetNeedleValue(Value);
            
            AGAUGE9.SetNeedleID(2);
            if (AGAUGE9.GetNeedleValue() < Value) 
                AGAUGE9.SetNeedleValue(Value);
            
            AGAUGE9.SetNeedleID(1);
			break;
		}
}
